/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.1 Revision 1.343
1# Copyright 1999-2002 Gentoo Technologies, Inc. 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# Author: Martin Schlemmer <azarah@gentoo.org>
4# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.1 2002/10/26 09:16:03 azarah Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.343 2010/05/11 20:08:02 mr_bones_ Exp $
5# This eclass is for general purpose functions that most ebuilds
6# have to implement themselfs.
7#
8# NB: If you add anything, please comment it!
9 4
10ECLASS=eutils 5# @ECLASS: eutils.eclass
11INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
12 17
13newdepend sys-devel/patch 18inherit multilib portability
14 19
15DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
16 21
17# This function generate linker scripts in /usr/lib for dynamic 22if has "${EAPI:-0}" 0 1 2; then
18# libs in /lib. This is to fix linking problems when you have
19# the .so in /lib, and the .a in /usr/lib. What happens is that
20# in some cases when linking dynamic, the .a in /usr/lib is used
21# instead of the .so in /lib due to gcc/libtool tweaking ld's
22# library search path. This cause many builds to fail.
23# See bug #4411 for more info.
24#
25# To use, simply call:
26#
27# gen_usr_ldscript libfoo.so
28#
29# Note that you should in general use the unversioned name of
30# the library, as ldconfig should usually update it correctly
31# to point to the latest version of the library present.
32#
33# <azarah@gentoo.org> (26 Oct 2002)
34#
35gen_usr_ldscript() {
36 23
37 # Just make sure it exists 24# @FUNCTION: epause
38 dodir /usr/lib 25# @USAGE: [seconds]
39 26# @DESCRIPTION:
40 cat > ${D}/usr/lib/$1 <<"END_LDSCRIPT" 27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
41/* GNU ld script 28# printing a message the user should probably be reading and often used in
42 Because Gentoo have critical dynamic libraries 29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
43 in /lib, and the static versions in /usr/lib, we 30# don't wait at all. Defined in EAPIs 0 1 and 2.
44 need to have a "fake" dynamic lib in /usr/lib, 31epause() {
45 otherwise we run into linking problems. 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
46 See bug #4411 on http://bugs.gentoo.org/ for
47 more info. */
48GROUP ( /lib/libxxx )
49END_LDSCRIPT
50
51 dosed "s:libxxx:$1:" /usr/lib/$1
52} 33}
53 34
35# @FUNCTION: ebeep
36# @USAGE: [number of beeps]
37# @DESCRIPTION:
38# Issue the specified number of beeps (default of 5 beeps). Useful when
39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
42ebeep() {
43 local n
44 if [[ -z ${EBEEP_IGNORE} ]] ; then
45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
46 echo -ne "\a"
47 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
48 echo -ne "\a"
49 sleep 1
50 done
51 fi
52}
53
54else
55
56ebeep() {
57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
58}
59
60epause() {
61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
62}
63
64fi
65
66# @FUNCTION: ecvs_clean
67# @USAGE: [list of dirs]
68# @DESCRIPTION:
69# Remove CVS directories recursiveley. Useful when a source tarball contains
70# internal CVS directories. Defaults to $PWD.
71ecvs_clean() {
72 [[ -z $* ]] && set -- .
73 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
74 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
75}
76
77# @FUNCTION: esvn_clean
78# @USAGE: [list of dirs]
79# @DESCRIPTION:
80# Remove .svn directories recursiveley. Useful when a source tarball contains
81# internal Subversion directories. Defaults to $PWD.
82esvn_clean() {
83 [[ -z $* ]] && set -- .
84 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
85}
86
87# @FUNCTION: eshopts_push
88# @USAGE: [options to `set` or `shopt`]
89# @DESCRIPTION:
90# Often times code will want to enable a shell option to change code behavior.
91# Since changing shell options can easily break other pieces of code (which
92# assume the default state), eshopts_push is used to (1) push the current shell
93# options onto a stack and (2) pass the specified arguments to set.
94#
95# If the first argument is '-s' or '-u', we assume you want to call `shopt`
96# rather than `set` as there are some options only available via that.
97#
98# A common example is to disable shell globbing so that special meaning/care
99# may be used with variables/arguments to custom functions. That would be:
100# @CODE
101# eshopts_push -o noglob
102# for x in ${foo} ; do
103# if ...some check... ; then
104# eshopts_pop
105# return 0
106# fi
107# done
108# eshopts_pop
109# @CODE
110eshopts_push() {
111 # have to assume __ESHOPTS_SAVE__ isn't screwed with
112 # as a `declare -a` here will reset its value
113 local i=${#__ESHOPTS_SAVE__[@]}
114 if [[ $1 == -[su] ]] ; then
115 __ESHOPTS_SAVE__[$i]=$(shopt -p)
116 [[ $# -eq 0 ]] && return 0
117 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
118 else
119 __ESHOPTS_SAVE__[$i]=$-
120 [[ $# -eq 0 ]] && return 0
121 set "$@" || die "eshopts_push: bad options to set: $*"
122 fi
123}
124
125# @FUNCTION: eshopts_pop
126# @USAGE:
127# @DESCRIPTION:
128# Restore the shell options to the state saved with the corresponding
129# eshopts_push call. See that function for more details.
130eshopts_pop() {
131 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
132 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
133 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
134 local s=${__ESHOPTS_SAVE__[$i]}
135 unset __ESHOPTS_SAVE__[$i]
136 if [[ ${s} == "shopt -"* ]] ; then
137 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
138 else
139 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
140 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
141 fi
142}
143
144# @VARIABLE: EPATCH_SOURCE
145# @DESCRIPTION:
146# Default directory to search for patches.
147EPATCH_SOURCE="${WORKDIR}/patch"
148# @VARIABLE: EPATCH_SUFFIX
149# @DESCRIPTION:
150# Default extension for patches (do not prefix the period yourself).
151EPATCH_SUFFIX="patch.bz2"
152# @VARIABLE: EPATCH_OPTS
153# @DESCRIPTION:
154# Default options for patch:
155# @CODE
156# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
157# --no-backup-if-mismatch - do not leave .orig files behind
158# -E - automatically remove empty files
159# @CODE
160EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
161# @VARIABLE: EPATCH_EXCLUDE
162# @DESCRIPTION:
163# List of patches not to apply. Note this is only file names,
164# and not the full path. Globs accepted.
165EPATCH_EXCLUDE=""
166# @VARIABLE: EPATCH_SINGLE_MSG
167# @DESCRIPTION:
168# Change the printed message for a single patch.
169EPATCH_SINGLE_MSG=""
170# @VARIABLE: EPATCH_MULTI_MSG
171# @DESCRIPTION:
172# Change the printed message for multiple patches.
173EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
174# @VARIABLE: EPATCH_FORCE
175# @DESCRIPTION:
176# Only require patches to match EPATCH_SUFFIX rather than the extended
177# arch naming style.
178EPATCH_FORCE="no"
179
180# @FUNCTION: epatch
181# @USAGE: [patches] [dirs of patches]
182# @DESCRIPTION:
183# epatch is designed to greatly simplify the application of patches. It can
184# process patch files directly, or directories of patches. The patches may be
185# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
186# the -p option as epatch will automatically attempt -p0 to -p5 until things
187# apply successfully.
188#
189# If you do not specify any options, then epatch will default to the directory
190# specified by EPATCH_SOURCE.
191#
192# When processing directories, epatch will apply all patches that match:
193# @CODE
194# ${EPATCH_FORCE} == "yes"
195# ??_${ARCH}_foo.${EPATCH_SUFFIX}
196# else
197# *.${EPATCH_SUFFIX}
198# @CODE
199# The leading ?? are typically numbers used to force consistent patch ordering.
200# The arch field is used to apply patches only for the host architecture with
201# the special value of "all" means apply for everyone. Note that using values
202# other than "all" is highly discouraged -- you should apply patches all the
203# time and let architecture details be detected at configure/compile time.
204#
205# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
206# for patches to apply.
207#
208# Refer to the other EPATCH_xxx variables for more customization of behavior.
209epatch() {
210 _epatch_draw_line() {
211 # create a line of same length as input string
212 [[ -z $1 ]] && set "$(printf "%65s" '')"
213 echo "${1//?/=}"
214 }
215
216 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
217
218 # Let the rest of the code process one user arg at a time --
219 # each arg may expand into multiple patches, and each arg may
220 # need to start off with the default global EPATCH_xxx values
221 if [[ $# -gt 1 ]] ; then
222 local m
223 for m in "$@" ; do
224 epatch "${m}"
225 done
226 return 0
227 fi
228
229 local SINGLE_PATCH="no"
230 # no args means process ${EPATCH_SOURCE}
231 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
232
233 if [[ -f $1 ]] ; then
234 SINGLE_PATCH="yes"
235 set -- "$1"
236 # Use the suffix from the single patch (localize it); the code
237 # below will find the suffix for us
238 local EPATCH_SUFFIX=$1
239
240 elif [[ -d $1 ]] ; then
241 # Some people like to make dirs of patches w/out suffixes (vim)
242 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
243
244 else
245 # sanity check ... if it isn't a dir or file, wtf man ?
246 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
247 echo
248 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
249 eerror
250 eerror " ${EPATCH_SOURCE}"
251 eerror " ( ${EPATCH_SOURCE##*/} )"
252 echo
253 die "Cannot find \$EPATCH_SOURCE!"
254 fi
255
256 local PIPE_CMD
257 case ${EPATCH_SUFFIX##*\.} in
258 xz) PIPE_CMD="xz -dc" ;;
259 lzma) PIPE_CMD="lzma -dc" ;;
260 bz2) PIPE_CMD="bzip2 -dc" ;;
261 gz|Z|z) PIPE_CMD="gzip -dc" ;;
262 ZIP|zip) PIPE_CMD="unzip -p" ;;
263 *) ;;
264 esac
265
266 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
267
268 local x
269 for x in "$@" ; do
270 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
271 # didn't match anything, ignore continue on
272 [[ ! -f ${x} ]] && continue
273
274 local patchname=${x##*/}
275
276 # Apply single patches, or forced sets of patches, or
277 # patches with ARCH dependant names.
278 # ???_arch_foo.patch
279 # Else, skip this input altogether
280 local a=${patchname#*_} # strip the ???_
281 a=${a%%_*} # strip the _foo.patch
282 if ! [[ ${SINGLE_PATCH} == "yes" || \
283 ${EPATCH_FORCE} == "yes" || \
284 ${a} == all || \
285 ${a} == ${ARCH} ]]
286 then
287 continue
288 fi
289
290 # Let people filter things dynamically
291 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
292 # let people use globs in the exclude
293 eshopts_push -o noglob
294
295 local ex
296 for ex in ${EPATCH_EXCLUDE} ; do
297 if [[ ${patchname} == ${ex} ]] ; then
298 eshopts_pop
299 continue 2
300 fi
301 done
302
303 eshopts_pop
304 fi
305
306 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
307 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
308 einfo "${EPATCH_SINGLE_MSG}"
309 else
310 einfo "Applying ${patchname} ..."
311 fi
312 else
313 einfo " ${patchname} ..."
314 fi
315
316 # most of the time, there will only be one run per unique name,
317 # but if there are more, make sure we get unique log filenames
318 local STDERR_TARGET="${T}/${patchname}.out"
319 if [[ -e ${STDERR_TARGET} ]] ; then
320 STDERR_TARGET="${T}/${patchname}-$$.out"
321 fi
322
323 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
324
325 # Decompress the patch if need be
326 local count=0
327 local PATCH_TARGET
328 if [[ -n ${PIPE_CMD} ]] ; then
329 PATCH_TARGET="${T}/$$.patch"
330 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
331
332 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
333 echo
334 eerror "Could not extract patch!"
335 #die "Could not extract patch!"
336 count=5
337 break
338 fi
339 else
340 PATCH_TARGET=${x}
341 fi
342
343 # Check for absolute paths in patches. If sandbox is disabled,
344 # people could (accidently) patch files in the root filesystem.
345 # Or trigger other unpleasantries #237667. So disallow -p0 on
346 # such patches.
347 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
348 if [[ -n ${abs_paths} ]] ; then
349 count=1
350 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
351 fi
352
353 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
354 while [[ ${count} -lt 5 ]] ; do
355 # Generate some useful debug info ...
356 (
357 _epatch_draw_line "***** ${patchname} *****"
358 echo
359 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
360 echo
361 _epatch_draw_line "***** ${patchname} *****"
362 ) >> "${STDERR_TARGET}"
363
364 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
365 (
366 _epatch_draw_line "***** ${patchname} *****"
367 echo
368 echo "ACTUALLY APPLYING ${patchname} ..."
369 echo
370 _epatch_draw_line "***** ${patchname} *****"
371 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
372 ) >> "${STDERR_TARGET}"
373
374 if [ $? -ne 0 ] ; then
375 echo
376 eerror "A dry-run of patch command succeeded, but actually"
377 eerror "applying the patch failed!"
378 #die "Real world sux compared to the dreamworld!"
379 count=5
380 fi
381 break
382 fi
383
384 : $(( count++ ))
385 done
386
387 # if we had to decompress the patch, delete the temp one
388 if [[ -n ${PIPE_CMD} ]] ; then
389 rm -f "${PATCH_TARGET}"
390 fi
391
392 if [[ ${count} -ge 5 ]] ; then
393 echo
394 eerror "Failed Patch: ${patchname} !"
395 eerror " ( ${PATCH_TARGET} )"
396 eerror
397 eerror "Include in your bugreport the contents of:"
398 eerror
399 eerror " ${STDERR_TARGET}"
400 echo
401 die "Failed Patch: ${patchname}!"
402 fi
403
404 # if everything worked, delete the patch log
405 rm -f "${STDERR_TARGET}"
406 eend 0
407 done
408
409 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
410 : # everything worked
411}
412epatch_user() {
413 [[ $# -ne 0 ]] && die "epatch_user takes no options"
414
415 # don't clobber any EPATCH vars that the parent might want
416 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
417 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
418 EPATCH_SOURCE=${base}/${CTARGET}/${check}
419 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
420 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
421 if [[ -d ${EPATCH_SOURCE} ]] ; then
422 EPATCH_SOURCE=${EPATCH_SOURCE} \
423 EPATCH_SUFFIX="patch" \
424 EPATCH_FORCE="yes" \
425 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
426 epatch
427 break
428 fi
429 done
430}
431
432# @FUNCTION: emktemp
433# @USAGE: [temp dir]
434# @DESCRIPTION:
435# Cheap replacement for when debianutils (and thus mktemp)
436# does not exist on the users system.
437emktemp() {
438 local exe="touch"
439 [[ $1 == -d ]] && exe="mkdir" && shift
440 local topdir=$1
441
442 if [[ -z ${topdir} ]] ; then
443 [[ -z ${T} ]] \
444 && topdir="/tmp" \
445 || topdir=${T}
446 fi
447
448 if ! type -P mktemp > /dev/null ; then
449 # system lacks `mktemp` so we have to fake it
450 local tmp=/
451 while [[ -e ${tmp} ]] ; do
452 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
453 done
454 ${exe} "${tmp}" || ${exe} -p "${tmp}"
455 echo "${tmp}"
456 else
457 # the args here will give slightly wierd names on BSD,
458 # but should produce a usable file on all userlands
459 if [[ ${exe} == "touch" ]] ; then
460 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
461 else
462 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
463 fi
464 fi
465}
466
467# @FUNCTION: egetent
468# @USAGE: <database> <key>
469# @MAINTAINER:
470# base-system@gentoo.org (Linux)
471# Joe Jezak <josejx@gmail.com> (OS X)
472# usata@gentoo.org (OS X)
473# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
474# @DESCRIPTION:
475# Small wrapper for getent (Linux),
476# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
477# and pw (FreeBSD) used in enewuser()/enewgroup()
478egetent() {
479 case ${CHOST} in
480 *-darwin[678])
481 case "$2" in
482 *[!0-9]*) # Non numeric
483 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
484 ;;
485 *) # Numeric
486 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
487 ;;
488 esac
489 ;;
490 *-darwin*)
491 local mytype=$1
492 [[ "passwd" == $mytype ]] && mytype="Users"
493 [[ "group" == $mytype ]] && mytype="Groups"
494 case "$2" in
495 *[!0-9]*) # Non numeric
496 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
497 ;;
498 *) # Numeric
499 local mykey="UniqueID"
500 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
501 dscl . -search /$mytype $mykey $2 2>/dev/null
502 ;;
503 esac
504 ;;
505 *-freebsd*|*-dragonfly*)
506 local opts action="user"
507 [[ $1 == "passwd" ]] || action="group"
508
509 # lookup by uid/gid
510 if [[ $2 == [[:digit:]]* ]] ; then
511 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
512 fi
513
514 pw show ${action} ${opts} "$2" -q
515 ;;
516 *-netbsd*|*-openbsd*)
517 grep "$2:\*:" /etc/$1
518 ;;
519 *)
520 type -p nscd >& /dev/null && nscd -i "$1"
521 getent "$1" "$2"
522 ;;
523 esac
524}
525
526# @FUNCTION: enewuser
527# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
528# @DESCRIPTION:
529# Same as enewgroup, you are not required to understand how to properly add
530# a user to the system. The only required parameter is the username.
531# Default uid is (pass -1 for this) next available, default shell is
532# /bin/false, default homedir is /dev/null, there are no default groups,
533# and default params sets the comment as 'added by portage for ${PN}'.
534enewuser() {
535 case ${EBUILD_PHASE} in
536 unpack|compile|test|install)
537 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
538 eerror "Package fails at QA and at life. Please file a bug."
539 die "Bad package! enewuser is only for use in pkg_* functions!"
540 esac
541
542 # get the username
543 local euser=$1; shift
544 if [[ -z ${euser} ]] ; then
545 eerror "No username specified !"
546 die "Cannot call enewuser without a username"
547 fi
548
549 # lets see if the username already exists
550 if [[ -n $(egetent passwd "${euser}") ]] ; then
551 return 0
552 fi
553 einfo "Adding user '${euser}' to your system ..."
554
555 # options to pass to useradd
556 local opts=
557
558 # handle uid
559 local euid=$1; shift
560 if [[ -n ${euid} && ${euid} != -1 ]] ; then
561 if [[ ${euid} -gt 0 ]] ; then
562 if [[ -n $(egetent passwd ${euid}) ]] ; then
563 euid="next"
564 fi
565 else
566 eerror "Userid given but is not greater than 0 !"
567 die "${euid} is not a valid UID"
568 fi
569 else
570 euid="next"
571 fi
572 if [[ ${euid} == "next" ]] ; then
573 for ((euid = 101; euid <= 999; euid++)); do
574 [[ -z $(egetent passwd ${euid}) ]] && break
575 done
576 fi
577 opts="${opts} -u ${euid}"
578 einfo " - Userid: ${euid}"
579
580 # handle shell
581 local eshell=$1; shift
582 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
583 if [[ ! -e ${ROOT}${eshell} ]] ; then
584 eerror "A shell was specified but it does not exist !"
585 die "${eshell} does not exist in ${ROOT}"
586 fi
587 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
588 eerror "Do not specify ${eshell} yourself, use -1"
589 die "Pass '-1' as the shell parameter"
590 fi
591 else
592 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
593 [[ -x ${ROOT}${shell} ]] && break
594 done
595
596 if [[ ${shell} == "/dev/null" ]] ; then
597 eerror "Unable to identify the shell to use, proceeding with userland default."
598 case ${USERLAND} in
599 GNU) shell="/bin/false" ;;
600 BSD) shell="/sbin/nologin" ;;
601 Darwin) shell="/usr/sbin/nologin" ;;
602 *) die "Unable to identify the default shell for userland ${USERLAND}"
603 esac
604 fi
605
606 eshell=${shell}
607 fi
608 einfo " - Shell: ${eshell}"
609 opts="${opts} -s ${eshell}"
610
611 # handle homedir
612 local ehome=$1; shift
613 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
614 ehome="/dev/null"
615 fi
616 einfo " - Home: ${ehome}"
617 opts="${opts} -d ${ehome}"
618
619 # handle groups
620 local egroups=$1; shift
621 if [[ ! -z ${egroups} ]] ; then
622 local oldifs=${IFS}
623 local defgroup="" exgroups=""
624
625 export IFS=","
626 for g in ${egroups} ; do
627 export IFS=${oldifs}
628 if [[ -z $(egetent group "${g}") ]] ; then
629 eerror "You must add group ${g} to the system first"
630 die "${g} is not a valid GID"
631 fi
632 if [[ -z ${defgroup} ]] ; then
633 defgroup=${g}
634 else
635 exgroups="${exgroups},${g}"
636 fi
637 export IFS=","
638 done
639 export IFS=${oldifs}
640
641 opts="${opts} -g ${defgroup}"
642 if [[ ! -z ${exgroups} ]] ; then
643 opts="${opts} -G ${exgroups:1}"
644 fi
645 else
646 egroups="(none)"
647 fi
648 einfo " - Groups: ${egroups}"
649
650 # handle extra and add the user
651 local oldsandbox=${SANDBOX_ON}
652 export SANDBOX_ON="0"
653 case ${CHOST} in
654 *-darwin*)
655 ### Make the user
656 if [[ -z $@ ]] ; then
657 dscl . create /users/${euser} uid ${euid}
658 dscl . create /users/${euser} shell ${eshell}
659 dscl . create /users/${euser} home ${ehome}
660 dscl . create /users/${euser} realname "added by portage for ${PN}"
661 ### Add the user to the groups specified
662 local oldifs=${IFS}
663 export IFS=","
664 for g in ${egroups} ; do
665 dscl . merge /groups/${g} users ${euser}
666 done
667 export IFS=${oldifs}
668 else
669 einfo "Extra options are not supported on Darwin yet"
670 einfo "Please report the ebuild along with the info below"
671 einfo "eextra: $@"
672 die "Required function missing"
673 fi
674 ;;
675 *-freebsd*|*-dragonfly*)
676 if [[ -z $@ ]] ; then
677 pw useradd ${euser} ${opts} \
678 -c "added by portage for ${PN}" \
679 die "enewuser failed"
680 else
681 einfo " - Extra: $@"
682 pw useradd ${euser} ${opts} \
683 "$@" || die "enewuser failed"
684 fi
685 ;;
686
687 *-netbsd*)
688 if [[ -z $@ ]] ; then
689 useradd ${opts} ${euser} || die "enewuser failed"
690 else
691 einfo " - Extra: $@"
692 useradd ${opts} ${euser} "$@" || die "enewuser failed"
693 fi
694 ;;
695
696 *-openbsd*)
697 if [[ -z $@ ]] ; then
698 useradd -u ${euid} -s ${eshell} \
699 -d ${ehome} -c "Added by portage for ${PN}" \
700 -g ${egroups} ${euser} || die "enewuser failed"
701 else
702 einfo " - Extra: $@"
703 useradd -u ${euid} -s ${eshell} \
704 -d ${ehome} -c "Added by portage for ${PN}" \
705 -g ${egroups} ${euser} "$@" || die "enewuser failed"
706 fi
707 ;;
708
709 *)
710 if [[ -z $@ ]] ; then
711 useradd ${opts} \
712 -c "added by portage for ${PN}" \
713 ${euser} \
714 || die "enewuser failed"
715 else
716 einfo " - Extra: $@"
717 useradd ${opts} "$@" \
718 ${euser} \
719 || die "enewuser failed"
720 fi
721 ;;
722 esac
723
724 if [[ ! -e ${ROOT}/${ehome} ]] ; then
725 einfo " - Creating ${ehome} in ${ROOT}"
726 mkdir -p "${ROOT}/${ehome}"
727 chown ${euser} "${ROOT}/${ehome}"
728 chmod 755 "${ROOT}/${ehome}"
729 fi
730
731 export SANDBOX_ON=${oldsandbox}
732}
733
734# @FUNCTION: enewgroup
735# @USAGE: <group> [gid]
736# @DESCRIPTION:
737# This function does not require you to understand how to properly add a
738# group to the system. Just give it a group name to add and enewgroup will
739# do the rest. You may specify the gid for the group or allow the group to
740# allocate the next available one.
741enewgroup() {
742 case ${EBUILD_PHASE} in
743 unpack|compile|test|install)
744 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
745 eerror "Package fails at QA and at life. Please file a bug."
746 die "Bad package! enewgroup is only for use in pkg_* functions!"
747 esac
748
749 # get the group
750 local egroup="$1"; shift
751 if [ -z "${egroup}" ]
752 then
753 eerror "No group specified !"
754 die "Cannot call enewgroup without a group"
755 fi
756
757 # see if group already exists
758 if [[ -n $(egetent group "${egroup}") ]]; then
759 return 0
760 fi
761 einfo "Adding group '${egroup}' to your system ..."
762
763 # options to pass to useradd
764 local opts=
765
766 # handle gid
767 local egid="$1"; shift
768 if [ ! -z "${egid}" ]
769 then
770 if [ "${egid}" -gt 0 ]
771 then
772 if [ -z "`egetent group ${egid}`" ]
773 then
774 if [[ "${CHOST}" == *-darwin* ]]; then
775 opts="${opts} ${egid}"
776 else
777 opts="${opts} -g ${egid}"
778 fi
779 else
780 egid="next available; requested gid taken"
781 fi
782 else
783 eerror "Groupid given but is not greater than 0 !"
784 die "${egid} is not a valid GID"
785 fi
786 else
787 egid="next available"
788 fi
789 einfo " - Groupid: ${egid}"
790
791 # handle extra
792 local eextra="$@"
793 opts="${opts} ${eextra}"
794
795 # add the group
796 local oldsandbox="${SANDBOX_ON}"
797 export SANDBOX_ON="0"
798 case ${CHOST} in
799 *-darwin*)
800 if [ ! -z "${eextra}" ];
801 then
802 einfo "Extra options are not supported on Darwin/OS X yet"
803 einfo "Please report the ebuild along with the info below"
804 einfo "eextra: ${eextra}"
805 die "Required function missing"
806 fi
807
808 # If we need the next available
809 case ${egid} in
810 *[!0-9]*) # Non numeric
811 for ((egid = 101; egid <= 999; egid++)); do
812 [[ -z $(egetent group ${egid}) ]] && break
813 done
814 esac
815 dscl . create /groups/${egroup} gid ${egid}
816 dscl . create /groups/${egroup} passwd '*'
817 ;;
818
819 *-freebsd*|*-dragonfly*)
820 case ${egid} in
821 *[!0-9]*) # Non numeric
822 for ((egid = 101; egid <= 999; egid++)); do
823 [[ -z $(egetent group ${egid}) ]] && break
824 done
825 esac
826 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
827 ;;
828
829 *-netbsd*)
830 case ${egid} in
831 *[!0-9]*) # Non numeric
832 for ((egid = 101; egid <= 999; egid++)); do
833 [[ -z $(egetent group ${egid}) ]] && break
834 done
835 esac
836 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
837 ;;
838
839 *)
840 groupadd ${opts} ${egroup} || die "enewgroup failed"
841 ;;
842 esac
843 export SANDBOX_ON="${oldsandbox}"
844}
845
846# @FUNCTION: edos2unix
847# @USAGE: <file> [more files ...]
848# @DESCRIPTION:
849# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
850# to remove all of these text utilities from DEPEND variables because this
851# is a script based solution. Just give it a list of files to convert and
852# they will all be changed from the DOS CRLF format to the UNIX LF format.
853edos2unix() {
854 echo "$@" | xargs sed -i 's/\r$//'
855}
856
857# Make a desktop file !
858# Great for making those icons in kde/gnome startmenu !
859# Amaze your friends ! Get the women ! Join today !
860#
861# make_desktop_entry(<command>, [name], [icon], [type], [fields])
862#
863# binary: what command does the app run with ?
864# name: the name that will show up in the menu
865# icon: give your little like a pretty little icon ...
866# this can be relative (to /usr/share/pixmaps) or
867# a full path to an icon
868# type: what kind of application is this ? for categories:
869# http://standards.freedesktop.org/menu-spec/latest/apa.html
870# fields: extra fields to append to the desktop file; a printf string
871make_desktop_entry() {
872 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
873
874 local exec=${1}
875 local name=${2:-${PN}}
876 local icon=${3:-${PN}}
877 local type=${4}
878 local fields=${5}
879
880 if [[ -z ${type} ]] ; then
881 local catmaj=${CATEGORY%%-*}
882 local catmin=${CATEGORY##*-}
883 case ${catmaj} in
884 app)
885 case ${catmin} in
886 accessibility) type=Accessibility;;
887 admin) type=System;;
888 antivirus) type=System;;
889 arch) type=Archiving;;
890 backup) type=Archiving;;
891 cdr) type=DiscBurning;;
892 dicts) type=Dictionary;;
893 doc) type=Documentation;;
894 editors) type=TextEditor;;
895 emacs) type=TextEditor;;
896 emulation) type=Emulator;;
897 laptop) type=HardwareSettings;;
898 office) type=Office;;
899 pda) type=PDA;;
900 vim) type=TextEditor;;
901 xemacs) type=TextEditor;;
902 esac
903 ;;
904
905 dev)
906 type="Development"
907 ;;
908
909 games)
910 case ${catmin} in
911 action|fps) type=ActionGame;;
912 arcade) type=ArcadeGame;;
913 board) type=BoardGame;;
914 emulation) type=Emulator;;
915 kids) type=KidsGame;;
916 puzzle) type=LogicGame;;
917 roguelike) type=RolePlaying;;
918 rpg) type=RolePlaying;;
919 simulation) type=Simulation;;
920 sports) type=SportsGame;;
921 strategy) type=StrategyGame;;
922 esac
923 type="Game;${type}"
924 ;;
925
926 gnome)
927 type="Gnome;GTK"
928 ;;
929
930 kde)
931 type="KDE;Qt"
932 ;;
933
934 mail)
935 type="Network;Email"
936 ;;
937
938 media)
939 case ${catmin} in
940 gfx)
941 type=Graphics
942 ;;
943 *)
944 case ${catmin} in
945 radio) type=Tuner;;
946 sound) type=Audio;;
947 tv) type=TV;;
948 video) type=Video;;
949 esac
950 type="AudioVideo;${type}"
951 ;;
952 esac
953 ;;
954
955 net)
956 case ${catmin} in
957 dialup) type=Dialup;;
958 ftp) type=FileTransfer;;
959 im) type=InstantMessaging;;
960 irc) type=IRCClient;;
961 mail) type=Email;;
962 news) type=News;;
963 nntp) type=News;;
964 p2p) type=FileTransfer;;
965 voip) type=Telephony;;
966 esac
967 type="Network;${type}"
968 ;;
969
970 sci)
971 case ${catmin} in
972 astro*) type=Astronomy;;
973 bio*) type=Biology;;
974 calc*) type=Calculator;;
975 chem*) type=Chemistry;;
976 elec*) type=Electronics;;
977 geo*) type=Geology;;
978 math*) type=Math;;
979 physics) type=Physics;;
980 visual*) type=DataVisualization;;
981 esac
982 type="Education;Science;${type}"
983 ;;
984
985 sys)
986 type="System"
987 ;;
988
989 www)
990 case ${catmin} in
991 client) type=WebBrowser;;
992 esac
993 type="Network;${type}"
994 ;;
995
996 *)
997 type=
998 ;;
999 esac
1000 fi
1001 if [ "${SLOT}" == "0" ] ; then
1002 local desktop_name="${PN}"
1003 else
1004 local desktop_name="${PN}-${SLOT}"
1005 fi
1006 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
1007 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
1008
1009 # Don't append another ";" when a valid category value is provided.
1010 type=${type%;}${type:+;}
1011
1012 eshopts_push -s extglob
1013 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1014 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1015 ewarn "allowed in .desktop files if the value is not an absolute path."
1016 icon=${icon%.@(xpm|png|svg)}
1017 fi
1018 eshopts_pop
1019
1020 cat <<-EOF > "${desktop}"
1021 [Desktop Entry]
1022 Name=${name}
1023 Type=Application
1024 Comment=${DESCRIPTION}
1025 Exec=${exec}
1026 TryExec=${exec%% *}
1027 Icon=${icon}
1028 Categories=${type}
1029 EOF
1030
1031 if [[ ${fields:-=} != *=* ]] ; then
1032 # 5th arg used to be value to Path=
1033 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1034 fields="Path=${fields}"
1035 fi
1036 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
1037
1038 (
1039 # wrap the env here so that the 'insinto' call
1040 # doesn't corrupt the env of the caller
1041 insinto /usr/share/applications
1042 doins "${desktop}"
1043 ) || die "installing desktop file failed"
1044}
1045
1046# @FUNCTION: validate_desktop_entries
1047# @USAGE: [directories]
1048# @MAINTAINER:
1049# Carsten Lohrke <carlo@gentoo.org>
1050# @DESCRIPTION:
1051# Validate desktop entries using desktop-file-utils
1052validate_desktop_entries() {
1053 if [[ -x /usr/bin/desktop-file-validate ]] ; then
1054 einfo "Checking desktop entry validity"
1055 local directories=""
1056 for d in /usr/share/applications $@ ; do
1057 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
1058 done
1059 if [[ -n ${directories} ]] ; then
1060 for FILE in $(find ${directories} -name "*\.desktop" \
1061 -not -path '*.hidden*' | sort -u 2>/dev/null)
1062 do
1063 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
1064 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
1065 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
1066 done
1067 fi
1068 echo ""
1069 else
1070 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
1071 fi
1072}
1073
1074# @FUNCTION: make_session_desktop
1075# @USAGE: <title> <command> [command args...]
1076# @DESCRIPTION:
1077# Make a GDM/KDM Session file. The title is the file to execute to start the
1078# Window Manager. The command is the name of the Window Manager.
1079#
1080# You can set the name of the file via the ${wm} variable.
1081make_session_desktop() {
1082 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
1083 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
1084
1085 local title=$1
1086 local command=$2
1087 local desktop=${T}/${wm:-${PN}}.desktop
1088 shift 2
1089
1090 cat <<-EOF > "${desktop}"
1091 [Desktop Entry]
1092 Name=${title}
1093 Comment=This session logs you into ${title}
1094 Exec=${command} $*
1095 TryExec=${command}
1096 Type=XSession
1097 EOF
1098
1099 (
1100 # wrap the env here so that the 'insinto' call
1101 # doesn't corrupt the env of the caller
1102 insinto /usr/share/xsessions
1103 doins "${desktop}"
1104 )
1105}
1106
1107# @FUNCTION: domenu
1108# @USAGE: <menus>
1109# @DESCRIPTION:
1110# Install the list of .desktop menu files into the appropriate directory
1111# (/usr/share/applications).
1112domenu() {
1113 (
1114 # wrap the env here so that the 'insinto' call
1115 # doesn't corrupt the env of the caller
1116 local i j ret=0
1117 insinto /usr/share/applications
1118 for i in "$@" ; do
1119 if [[ -f ${i} ]] ; then
1120 doins "${i}"
1121 ((ret+=$?))
1122 elif [[ -d ${i} ]] ; then
1123 for j in "${i}"/*.desktop ; do
1124 doins "${j}"
1125 ((ret+=$?))
1126 done
1127 else
1128 ((++ret))
1129 fi
1130 done
1131 exit ${ret}
1132 )
1133}
1134
1135# @FUNCTION: newmenu
1136# @USAGE: <menu> <newname>
1137# @DESCRIPTION:
1138# Like all other new* functions, install the specified menu as newname.
1139newmenu() {
1140 (
1141 # wrap the env here so that the 'insinto' call
1142 # doesn't corrupt the env of the caller
1143 insinto /usr/share/applications
1144 newins "$@"
1145 )
1146}
1147
1148# @FUNCTION: doicon
1149# @USAGE: <list of icons>
1150# @DESCRIPTION:
1151# Install the list of icons into the icon directory (/usr/share/pixmaps).
1152# This is useful in conjunction with creating desktop/menu files.
1153doicon() {
1154 (
1155 # wrap the env here so that the 'insinto' call
1156 # doesn't corrupt the env of the caller
1157 local i j ret
1158 insinto /usr/share/pixmaps
1159 for i in "$@" ; do
1160 if [[ -f ${i} ]] ; then
1161 doins "${i}"
1162 ((ret+=$?))
1163 elif [[ -d ${i} ]] ; then
1164 for j in "${i}"/*.png ; do
1165 doins "${j}"
1166 ((ret+=$?))
1167 done
1168 else
1169 ((++ret))
1170 fi
1171 done
1172 exit ${ret}
1173 )
1174}
1175
1176# @FUNCTION: newicon
1177# @USAGE: <icon> <newname>
1178# @DESCRIPTION:
1179# Like all other new* functions, install the specified icon as newname.
1180newicon() {
1181 (
1182 # wrap the env here so that the 'insinto' call
1183 # doesn't corrupt the env of the caller
1184 insinto /usr/share/pixmaps
1185 newins "$@"
1186 )
1187}
1188
1189# for internal use only (unpack_pdv and unpack_makeself)
1190find_unpackable_file() {
1191 local src=$1
1192 if [[ -z ${src} ]] ; then
1193 src=${DISTDIR}/${A}
1194 else
1195 if [[ -e ${DISTDIR}/${src} ]] ; then
1196 src=${DISTDIR}/${src}
1197 elif [[ -e ${PWD}/${src} ]] ; then
1198 src=${PWD}/${src}
1199 elif [[ -e ${src} ]] ; then
1200 src=${src}
1201 fi
1202 fi
1203 [[ ! -e ${src} ]] && return 1
1204 echo "${src}"
1205}
1206
1207# @FUNCTION: unpack_pdv
1208# @USAGE: <file to unpack> <size of off_t>
1209# @DESCRIPTION:
1210# Unpack those pesky pdv generated files ...
1211# They're self-unpacking programs with the binary package stuffed in
1212# the middle of the archive. Valve seems to use it a lot ... too bad
1213# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1214#
1215# You have to specify the off_t size ... I have no idea how to extract that
1216# information out of the binary executable myself. Basically you pass in
1217# the size of the off_t type (in bytes) on the machine that built the pdv
1218# archive.
1219#
1220# One way to determine this is by running the following commands:
1221#
1222# @CODE
1223# strings <pdv archive> | grep lseek
1224# strace -elseek <pdv archive>
1225# @CODE
1226#
1227# Basically look for the first lseek command (we do the strings/grep because
1228# sometimes the function call is _llseek or something) and steal the 2nd
1229# parameter. Here is an example:
1230#
1231# @CODE
1232# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1233# lseek
1234# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1235# lseek(3, -4, SEEK_END) = 2981250
1236# @CODE
1237#
1238# Thus we would pass in the value of '4' as the second parameter.
1239unpack_pdv() {
1240 local src=$(find_unpackable_file "$1")
1241 local sizeoff_t=$2
1242
1243 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1244 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1245
1246 local shrtsrc=$(basename "${src}")
1247 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1248 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1249 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1250
1251 # grab metadata for debug reasons
1252 local metafile=$(emktemp)
1253 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1254
1255 # rip out the final file name from the metadata
1256 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1257 datafile=$(basename "${datafile}")
1258
1259 # now lets uncompress/untar the file if need be
1260 local tmpfile=$(emktemp)
1261 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1262
1263 local iscompressed=$(file -b "${tmpfile}")
1264 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1265 iscompressed=1
1266 mv ${tmpfile}{,.Z}
1267 gunzip ${tmpfile}
1268 else
1269 iscompressed=0
1270 fi
1271 local istar=$(file -b "${tmpfile}")
1272 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1273 istar=1
1274 else
1275 istar=0
1276 fi
1277
1278 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1279 #dd if=${src} ibs=${metaskip} count=1 \
1280 # | dd ibs=${tailskip} skip=1 \
1281 # | gzip -dc \
1282 # > ${datafile}
1283 if [ ${iscompressed} -eq 1 ] ; then
1284 if [ ${istar} -eq 1 ] ; then
1285 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1286 | head -c $((${metaskip}-${tailskip})) \
1287 | tar -xzf -
1288 else
1289 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1290 | head -c $((${metaskip}-${tailskip})) \
1291 | gzip -dc \
1292 > ${datafile}
1293 fi
1294 else
1295 if [ ${istar} -eq 1 ] ; then
1296 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1297 | head -c $((${metaskip}-${tailskip})) \
1298 | tar --no-same-owner -xf -
1299 else
1300 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1301 | head -c $((${metaskip}-${tailskip})) \
1302 > ${datafile}
1303 fi
1304 fi
1305 true
1306 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1307 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1308}
1309
1310# @FUNCTION: unpack_makeself
1311# @USAGE: [file to unpack] [offset] [tail|dd]
1312# @DESCRIPTION:
1313# Unpack those pesky makeself generated files ...
1314# They're shell scripts with the binary package tagged onto
1315# the end of the archive. Loki utilized the format as does
1316# many other game companies.
1317#
1318# If the file is not specified, then ${A} is used. If the
1319# offset is not specified then we will attempt to extract
1320# the proper offset from the script itself.
1321unpack_makeself() {
1322 local src_input=${1:-${A}}
1323 local src=$(find_unpackable_file "${src_input}")
1324 local skip=$2
1325 local exe=$3
1326
1327 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1328
1329 local shrtsrc=$(basename "${src}")
1330 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1331 if [[ -z ${skip} ]] ; then
1332 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1333 local skip=0
1334 exe=tail
1335 case ${ver} in
1336 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1337 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1338 ;;
1339 2.0|2.0.1)
1340 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1341 ;;
1342 2.1.1)
1343 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1344 let skip="skip + 1"
1345 ;;
1346 2.1.2)
1347 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1348 let skip="skip + 1"
1349 ;;
1350 2.1.3)
1351 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1352 let skip="skip + 1"
1353 ;;
1354 2.1.4|2.1.5)
1355 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1356 skip=$(head -n ${skip} "${src}" | wc -c)
1357 exe="dd"
1358 ;;
1359 *)
1360 eerror "I'm sorry, but I was unable to support the Makeself file."
1361 eerror "The version I detected was '${ver}'."
1362 eerror "Please file a bug about the file ${shrtsrc} at"
1363 eerror "http://bugs.gentoo.org/ so that support can be added."
1364 die "makeself version '${ver}' not supported"
1365 ;;
1366 esac
1367 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1368 fi
1369 case ${exe} in
1370 tail) exe="tail -n +${skip} '${src}'";;
1371 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";;
1372 *) die "makeself cant handle exe '${exe}'"
1373 esac
1374
1375 # lets grab the first few bytes of the file to figure out what kind of archive it is
1376 local tmpfile=$(emktemp)
1377 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1378 local filetype=$(file -b "${tmpfile}")
1379 case ${filetype} in
1380 *tar\ archive*)
1381 eval ${exe} | tar --no-same-owner -xf -
1382 ;;
1383 bzip2*)
1384 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1385 ;;
1386 gzip*)
1387 eval ${exe} | tar --no-same-owner -xzf -
1388 ;;
1389 compress*)
1390 eval ${exe} | gunzip | tar --no-same-owner -xf -
1391 ;;
1392 *)
1393 eerror "Unknown filetype \"${filetype}\" ?"
1394 false
1395 ;;
1396 esac
1397 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1398}
1399
1400# @FUNCTION: check_license
1401# @USAGE: [license]
1402# @DESCRIPTION:
1403# Display a license for user to accept. If no license is
1404# specified, then ${LICENSE} is used.
1405check_license() {
1406 local lic=$1
1407 if [ -z "${lic}" ] ; then
1408 lic="${PORTDIR}/licenses/${LICENSE}"
1409 else
1410 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1411 lic="${PORTDIR}/licenses/${lic}"
1412 elif [ -e "${PWD}/${lic}" ] ; then
1413 lic="${PWD}/${lic}"
1414 elif [ -e "${lic}" ] ; then
1415 lic="${lic}"
1416 fi
1417 fi
1418 local l="`basename ${lic}`"
1419
1420 # here is where we check for the licenses the user already
1421 # accepted ... if we don't find a match, we make the user accept
1422 local alic
1423 eshopts_push -o noglob # so that bash doesn't expand "*"
1424 for alic in ${ACCEPT_LICENSE} ; do
1425 if [[ ${alic} == ${l} ]]; then
1426 eshopts_pop
1427 return 0
1428 fi
1429 done
1430 eshopts_pop
1431 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1432
1433 local licmsg=$(emktemp)
1434 cat <<-EOF > ${licmsg}
1435 **********************************************************
1436 The following license outlines the terms of use of this
1437 package. You MUST accept this license for installation to
1438 continue. When you are done viewing, hit 'q'. If you
1439 CTRL+C out of this, the install will not run!
1440 **********************************************************
1441
1442 EOF
1443 cat ${lic} >> ${licmsg}
1444 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1445 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1446 read alic
1447 case ${alic} in
1448 yes|Yes|y|Y)
1449 return 0
1450 ;;
1451 *)
1452 echo;echo;echo
1453 eerror "You MUST accept the license to continue! Exiting!"
1454 die "Failed to accept license"
1455 ;;
1456 esac
1457}
1458
1459# @FUNCTION: cdrom_get_cds
1460# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1461# @DESCRIPTION:
1462# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1463# the whole 'non-interactive' policy, but damnit I want CD support !
1464#
1465# With these cdrom functions we handle all the user interaction and
1466# standardize everything. All you have to do is call cdrom_get_cds()
1467# and when the function returns, you can assume that the cd has been
1468# found at CDROM_ROOT.
1469#
1470# The function will attempt to locate a cd based upon a file that is on
1471# the cd. The more files you give this function, the more cds
1472# the cdrom functions will handle.
1473#
1474# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1475# etc... If you want to give the cds better names, then just export
1476# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1477# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1478# also use the CDROM_NAME_SET bash array.
1479#
1480# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1481cdrom_get_cds() {
1482 # first we figure out how many cds we're dealing with by
1483 # the # of files they gave us
1484 local cdcnt=0
1485 local f=
1486 for f in "$@" ; do
1487 ((++cdcnt))
1488 export CDROM_CHECK_${cdcnt}="$f"
1489 done
1490 export CDROM_TOTAL_CDS=${cdcnt}
1491 export CDROM_CURRENT_CD=1
1492
1493 # now we see if the user gave use CD_ROOT ...
1494 # if they did, let's just believe them that it's correct
1495 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1496 local var=
1497 cdcnt=0
1498 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1499 ((++cdcnt))
1500 var="CD_ROOT_${cdcnt}"
1501 [[ -z ${!var} ]] && var="CD_ROOT"
1502 if [[ -z ${!var} ]] ; then
1503 eerror "You must either use just the CD_ROOT"
1504 eerror "or specify ALL the CD_ROOT_X variables."
1505 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1506 die "could not locate CD_ROOT_${cdcnt}"
1507 fi
1508 done
1509 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1510 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1511 export CDROM_SET=-1
1512 for f in ${CDROM_CHECK_1//:/ } ; do
1513 ((++CDROM_SET))
1514 [[ -e ${CD_ROOT}/${f} ]] && break
1515 done
1516 export CDROM_MATCH=${f}
1517 return
1518 fi
1519
1520 # User didn't help us out so lets make sure they know they can
1521 # simplify the whole process ...
1522 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1523 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1524 echo
1525 einfo "If you do not have the CD, but have the data files"
1526 einfo "mounted somewhere on your filesystem, just export"
1527 einfo "the variable CD_ROOT so that it points to the"
1528 einfo "directory containing the files."
1529 echo
1530 einfo "For example:"
1531 einfo "export CD_ROOT=/mnt/cdrom"
1532 echo
1533 else
1534 if [[ -n ${CDROM_NAME_SET} ]] ; then
1535 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1536 cdcnt=0
1537 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1538 ((++cdcnt))
1539 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1540 done
1541 fi
1542
1543 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1544 cdcnt=0
1545 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1546 ((++cdcnt))
1547 var="CDROM_NAME_${cdcnt}"
1548 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1549 done
1550 echo
1551 einfo "If you do not have the CDs, but have the data files"
1552 einfo "mounted somewhere on your filesystem, just export"
1553 einfo "the following variables so they point to the right place:"
1554 einfon ""
1555 cdcnt=0
1556 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1557 ((++cdcnt))
1558 echo -n " CD_ROOT_${cdcnt}"
1559 done
1560 echo
1561 einfo "Or, if you have all the files in the same place, or"
1562 einfo "you only have one cdrom, you can export CD_ROOT"
1563 einfo "and that place will be used as the same data source"
1564 einfo "for all the CDs."
1565 echo
1566 einfo "For example:"
1567 einfo "export CD_ROOT_1=/mnt/cdrom"
1568 echo
1569 fi
1570
1571 export CDROM_SET=""
1572 export CDROM_CURRENT_CD=0
1573 cdrom_load_next_cd
1574}
1575
1576# @FUNCTION: cdrom_load_next_cd
1577# @DESCRIPTION:
1578# Some packages are so big they come on multiple CDs. When you're done reading
1579# files off a CD and want access to the next one, just call this function.
1580# Again, all the messy details of user interaction are taken care of for you.
1581# Once this returns, just read the variable CDROM_ROOT for the location of the
1582# mounted CD. Note that you can only go forward in the CD list, so make sure
1583# you only call this function when you're done using the current CD.
1584cdrom_load_next_cd() {
1585 local var
1586 ((++CDROM_CURRENT_CD))
1587
1588 unset CDROM_ROOT
1589 var=CD_ROOT_${CDROM_CURRENT_CD}
1590 [[ -z ${!var} ]] && var="CD_ROOT"
1591 if [[ -z ${!var} ]] ; then
1592 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1593 _cdrom_locate_file_on_cd ${!var}
1594 else
1595 export CDROM_ROOT=${!var}
1596 fi
1597
1598 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1599}
1600
1601# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1602# functions. this should *never* be called from an ebuild.
1603# all it does is try to locate a give file on a cd ... if the cd isn't
1604# found, then a message asking for the user to insert the cdrom will be
1605# displayed and we'll hang out here until:
1606# (1) the file is found on a mounted cdrom
1607# (2) the user hits CTRL+C
1608_cdrom_locate_file_on_cd() {
1609 local mline=""
1610 local showedmsg=0 showjolietmsg=0
1611
1612 while [[ -z ${CDROM_ROOT} ]] ; do
1613 local i=0
1614 local -a cdset=(${*//:/ })
1615 if [[ -n ${CDROM_SET} ]] ; then
1616 cdset=(${cdset[${CDROM_SET}]})
1617 fi
1618
1619 while [[ -n ${cdset[${i}]} ]] ; do
1620 local dir=$(dirname ${cdset[${i}]})
1621 local file=$(basename ${cdset[${i}]})
1622
1623 local point= node= fs= foo=
1624 while read point node fs foo ; do
1625 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1626 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1627 && continue
1628 point=${point//\040/ }
1629 [[ ! -d ${point}/${dir} ]] && continue
1630 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1631 export CDROM_ROOT=${point}
1632 export CDROM_SET=${i}
1633 export CDROM_MATCH=${cdset[${i}]}
1634 return
1635 done <<< "$(get_mounts)"
1636
1637 ((++i))
1638 done
1639
1640 echo
1641 if [[ ${showedmsg} -eq 0 ]] ; then
1642 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1643 if [[ -z ${CDROM_NAME} ]] ; then
1644 einfo "Please insert+mount the cdrom for ${PN} now !"
1645 else
1646 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1647 fi
1648 else
1649 if [[ -z ${CDROM_NAME_1} ]] ; then
1650 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1651 else
1652 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1653 einfo "Please insert+mount the ${!var} cdrom now !"
1654 fi
1655 fi
1656 showedmsg=1
1657 fi
1658 einfo "Press return to scan for the cd again"
1659 einfo "or hit CTRL+C to abort the emerge."
1660 echo
1661 if [[ ${showjolietmsg} -eq 0 ]] ; then
1662 showjolietmsg=1
1663 else
1664 ewarn "If you are having trouble with the detection"
1665 ewarn "of your CD, it is possible that you do not have"
1666 ewarn "Joliet support enabled in your kernel. Please"
1667 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1668 ebeep 5
1669 fi
1670 read || die "something is screwed with your system"
1671 done
1672}
1673
1674# @FUNCTION: strip-linguas
1675# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1676# @DESCRIPTION:
1677# Make sure that LINGUAS only contains languages that
1678# a package can support. The first form allows you to
1679# specify a list of LINGUAS. The -i builds a list of po
1680# files found in all the directories and uses the
1681# intersection of the lists. The -u builds a list of po
1682# files found in all the directories and uses the union
1683# of the lists.
1684strip-linguas() {
1685 local ls newls nols
1686 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1687 local op=$1; shift
1688 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1689 local d f
1690 for d in "$@" ; do
1691 if [[ ${op} == "-u" ]] ; then
1692 newls=${ls}
1693 else
1694 newls=""
1695 fi
1696 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1697 if [[ ${op} == "-i" ]] ; then
1698 hasq ${f} ${ls} && newls="${newls} ${f}"
1699 else
1700 hasq ${f} ${ls} || newls="${newls} ${f}"
1701 fi
1702 done
1703 ls=${newls}
1704 done
1705 else
1706 ls="$@"
1707 fi
1708
1709 nols=""
1710 newls=""
1711 for f in ${LINGUAS} ; do
1712 if hasq ${f} ${ls} ; then
1713 newls="${newls} ${f}"
1714 else
1715 nols="${nols} ${f}"
1716 fi
1717 done
1718 [[ -n ${nols} ]] \
1719 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1720 export LINGUAS=${newls:1}
1721}
1722
1723# @FUNCTION: preserve_old_lib
1724# @USAGE: <libs to preserve> [more libs]
1725# @DESCRIPTION:
1726# These functions are useful when a lib in your package changes ABI SONAME.
1727# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1728# would break packages that link against it. Most people get around this
1729# by using the portage SLOT mechanism, but that is not always a relevant
1730# solution, so instead you can call this from pkg_preinst. See also the
1731# preserve_old_lib_notify function.
1732preserve_old_lib() {
1733 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1734 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1735 die "Invalid preserve_old_lib() usage"
1736 fi
1737 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1738
1739 # let portage worry about it
1740 has preserve-libs ${FEATURES} && return 0
1741
1742 local lib dir
1743 for lib in "$@" ; do
1744 [[ -e ${ROOT}/${lib} ]] || continue
1745 dir=${lib%/*}
1746 dodir ${dir} || die "dodir ${dir} failed"
1747 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1748 touch "${D}"/${lib}
1749 done
1750}
1751
1752# @FUNCTION: preserve_old_lib_notify
1753# @USAGE: <libs to notify> [more libs]
1754# @DESCRIPTION:
1755# Spit helpful messages about the libraries preserved by preserve_old_lib.
1756preserve_old_lib_notify() {
1757 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1758 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1759 die "Invalid preserve_old_lib_notify() usage"
1760 fi
1761
1762 # let portage worry about it
1763 has preserve-libs ${FEATURES} && return 0
1764
1765 local lib notice=0
1766 for lib in "$@" ; do
1767 [[ -e ${ROOT}/${lib} ]] || continue
1768 if [[ ${notice} -eq 0 ]] ; then
1769 notice=1
1770 ewarn "Old versions of installed libraries were detected on your system."
1771 ewarn "In order to avoid breaking packages that depend on these old libs,"
1772 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1773 ewarn "in order to remove these old dependencies. If you do not have this"
1774 ewarn "helper program, simply emerge the 'gentoolkit' package."
1775 ewarn
1776 fi
1777 ewarn " # revdep-rebuild --library ${lib##*/}"
1778 done
1779 if [[ ${notice} -eq 1 ]] ; then
1780 ewarn
1781 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1782 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1783 for lib in "$@" ; do
1784 ewarn " # rm '${lib}'"
1785 done
1786 fi
1787}
1788
1789# @FUNCTION: built_with_use
1790# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1791# @DESCRIPTION:
1792#
1793# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1794#
1795# A temporary hack until portage properly supports DEPENDing on USE
1796# flags being enabled in packages. This will check to see if the specified
1797# DEPEND atom was built with the specified list of USE flags. The
1798# --missing option controls the behavior if called on a package that does
1799# not actually support the defined USE flags (aka listed in IUSE).
1800# The default is to abort (call die). The -a and -o flags control
1801# the requirements of the USE flags. They correspond to "and" and "or"
1802# logic. So the -a flag means all listed USE flags must be enabled
1803# while the -o flag means at least one of the listed IUSE flags must be
1804# enabled. The --hidden option is really for internal use only as it
1805# means the USE flag we're checking is hidden expanded, so it won't be found
1806# in IUSE like normal USE flags.
1807#
1808# Remember that this function isn't terribly intelligent so order of optional
1809# flags matter.
1810built_with_use() {
1811 local hidden="no"
1812 if [[ $1 == "--hidden" ]] ; then
1813 hidden="yes"
1814 shift
1815 fi
1816
1817 local missing_action="die"
1818 if [[ $1 == "--missing" ]] ; then
1819 missing_action=$2
1820 shift ; shift
1821 case ${missing_action} in
1822 true|false|die) ;;
1823 *) die "unknown action '${missing_action}'";;
1824 esac
1825 fi
1826
1827 local opt=$1
1828 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1829
1830 local PKG=$(best_version $1)
1831 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1832 shift
1833
1834 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1835 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1836
1837 # if the IUSE file doesn't exist, the read will error out, we need to handle
1838 # this gracefully
1839 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1840 case ${missing_action} in
1841 true) return 0;;
1842 false) return 1;;
1843 die) die "Unable to determine what USE flags $PKG was built with";;
1844 esac
1845 fi
1846
1847 if [[ ${hidden} == "no" ]] ; then
1848 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1849 # Don't check USE_EXPAND #147237
1850 local expand
1851 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1852 if [[ $1 == ${expand}_* ]] ; then
1853 expand=""
1854 break
1855 fi
1856 done
1857 if [[ -n ${expand} ]] ; then
1858 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1859 case ${missing_action} in
1860 true) return 0;;
1861 false) return 1;;
1862 die) die "$PKG does not actually support the $1 USE flag!";;
1863 esac
1864 fi
1865 fi
1866 fi
1867
1868 local USE_BUILT=$(<${USEFILE})
1869 while [[ $# -gt 0 ]] ; do
1870 if [[ ${opt} = "-o" ]] ; then
1871 has $1 ${USE_BUILT} && return 0
1872 else
1873 has $1 ${USE_BUILT} || return 1
1874 fi
1875 shift
1876 done
1877 [[ ${opt} = "-a" ]]
1878}
1879
1880# @FUNCTION: epunt_cxx
1881# @USAGE: [dir to scan]
1882# @DESCRIPTION:
1883# Many configure scripts wrongly bail when a C++ compiler could not be
1884# detected. If dir is not specified, then it defaults to ${S}.
1885#
1886# http://bugs.gentoo.org/73450
1887epunt_cxx() {
1888 local dir=$1
1889 [[ -z ${dir} ]] && dir=${S}
1890 ebegin "Removing useless C++ checks"
1891 local f
1892 find "${dir}" -name configure | while read f ; do
1893 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1894 done
1895 eend 0
1896}
1897
1898# @FUNCTION: make_wrapper
1899# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1900# @DESCRIPTION:
1901# Create a shell wrapper script named wrapper in installpath
1902# (defaults to the bindir) to execute target (default of wrapper) by
1903# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1904# libpaths followed by optionally changing directory to chdir.
1905make_wrapper() {
1906 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1907 local tmpwrapper=$(emktemp)
1908 # We don't want to quote ${bin} so that people can pass complex
1909 # things as $bin ... "./someprog --args"
1910 cat << EOF > "${tmpwrapper}"
1911#!/bin/sh
1912cd "${chdir:-.}"
1913if [ -n "${libdir}" ] ; then
1914 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1915 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1916 else
1917 export LD_LIBRARY_PATH="${libdir}"
1918 fi
1919fi
1920exec ${bin} "\$@"
1921EOF
1922 chmod go+rx "${tmpwrapper}"
1923 if [[ -n ${path} ]] ; then
1924 (
1925 exeinto "${path}"
1926 newexe "${tmpwrapper}" "${wrapper}"
1927 ) || die
1928 else
1929 newbin "${tmpwrapper}" "${wrapper}" || die
1930 fi
1931}
1932
1933# @FUNCTION: prepalldocs
1934# @USAGE:
1935# @DESCRIPTION:
1936# Compress files in /usr/share/doc which are not already
1937# compressed, excluding /usr/share/doc/${PF}/html.
1938# Uses the ecompressdir to do the compression.
1939# 2009-02-18 by betelgeuse:
1940# Commented because ecompressdir is even more internal to
1941# Portage than prepalldocs (it's not even mentioned in man 5
1942# ebuild). Please submit a better version for review to gentoo-dev
1943# if you want prepalldocs here.
1944#prepalldocs() {
1945# if [[ -n $1 ]] ; then
1946# ewarn "prepalldocs: invalid usage; takes no arguments"
1947# fi
1948
1949# cd "${D}"
1950# [[ -d usr/share/doc ]] || return 0
1951
1952# find usr/share/doc -exec gzip {} +
1953# ecompressdir --ignore /usr/share/doc/${PF}/html
1954# ecompressdir --queue /usr/share/doc
1955#}

Legend:
Removed from v.1.1  
changed lines
  Added in v.1.343

  ViewVC Help
Powered by ViewVC 1.1.20